Unit asp4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure asp4e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; N :Integer; M :Integer;
                Z :Integer);

implementation

procedure asp4e(var A :Array of Extended; var B :Array of Extended;
                var X :Array of Extended; N :Integer; M :Integer;
                Z :Integer);
var
MZ,I,J,K,L :Integer;
R1,R2,R,P,T,C,S,A1,A2 :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
for I:=1 to N do
 begin
_1:
  X[I-1] := B[I-1];
 end;
MZ := 10;
if ( Z <> 1 ) 
 then goto _10;
MZ := 13;
for K:=1 to M do
 begin
  L := K+1;
  if ( L > N ) 
   then goto _9;
  for I:=L to N do
   begin
    R2 := A[(I-1)+(K-1)*N];
    if ( R2 = 0.0 ) 
     then goto _8;
    R1 := A[(K-1)+(K-1)*N];
    A1 := Abs(R1);
    A2 := Abs(R2);
    if ( A1 <> 0.0 ) 
     then goto _2;
    T := 1;
    A[(K-1)+(K-1)*N] := -A[(I-1)+(K-1)*N];
    goto _6;
_2:
    if ( A1 <= A2 ) 
     then goto _3;
    P := -R2/R1;
    R := Sqrt(1.0+P*P);
    T := P/(R+1.0);
    A[(K-1)+(K-1)*N] := R1*R;
    goto _6;
_3:
    P := -R1/R2;
    R := Sqrt(1.0+P*P);
    T := 1.0/(R+Abs(P));
    if ( P < 0.0 ) 
     then T := -T;
    if ( R1 ) < 0
     then goto _4
     else if ( R1 ) > 0
           then goto _5
           else goto _5;
_4:
    A[(K-1)+(K-1)*N] := -A2*R;
    goto _6;
_5:
    A[(K-1)+(K-1)*N] := A2*R;
_6:
    A[(I-1)+(K-1)*N] := T;
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    R1 := X[K-1];
    R2 := X[I-1];
    X[K-1] := C*R1-S*R2;
    X[I-1] := S*R1+C*R2;
    if ( L > M ) 
     then goto _8;
    for J:=L to M do
     begin
      R1 := A[(K-1)+(J-1)*N];
      R2 := A[(I-1)+(J-1)*N];
      A[(K-1)+(J-1)*N] := C*R1-S*R2;
      A[(I-1)+(J-1)*N] := S*R1+C*R2;
_7:
     end;
_8:
   end;
_9:
 end;
if ( MZ=10 ) then goto _10 else
if ( MZ=13 ) then goto _13;
_10:
for K:=1 to M do
 begin
  L := K+1;
  if ( L > N ) 
   then goto _12;
  for I:=L to N do
   begin
    T := A[(I-1)+(K-1)*N];
    R := T*T;
    R1 := 1.0/(1.0+R);
    C := (1.0-R)*R1;
    S := (T+T)*R1;
    R1 := X[K-1];
    R2 := X[I-1];
    X[K-1] := C*R1-S*R2;
    X[I-1] := S*R1+C*R2;
_11:
   end;
_12:
 end;
_13:
K := M;
R2 := 0.0;
_14:
R1 := X[K-1];
X[K-1] := (R1-R2)/A[(K-1)+(K-1)*N];
L := K;
K := K-1;
if ( K < 1 ) 
 then goto _16;
R2 := 0.0;
for J:=L to M do
 begin
_15:
  R2 := R2+A[(K-1)+(J-1)*N]*X[J-1];
 end;
goto _14;
_16:
end;

end.
